diff --git a/Castle.Core.sln b/Castle.Core.sln
index e46e795..66d0121 100644
--- a/Castle.Core.sln
+++ b/Castle.Core.sln
@@ -1,6 +1,6 @@
 ï»¿
 Microsoft Visual Studio Solution File, Format Version 12.00
-# Visual Studio 2013
+# Visual Studio 2012
 VisualStudioVersion = 12.0.31101.0
 MinimumVisualStudioVersion = 10.0.40219.1
 Project("{2150E333-8FDC-42A3-9474-1A3956D46DE8}") = "Solution Items", "Solution Items", "{8C53C104-3557-4C1A-B653-C4E6C46DB48E}"
@@ -36,33 +36,18 @@ Global
 		NET40-Debug|Any CPU = NET40-Debug|Any CPU
 		NET40-Release|Any CPU = NET40-Release|Any CPU
 		NET45-Debug|Any CPU = NET45-Debug|Any CPU
-		NET45-Release|Any CPU = NET45-Release|Any CPU
 		SL40-Debug|Any CPU = SL40-Debug|Any CPU
 		SL40-Release|Any CPU = SL40-Release|Any CPU
 		SL50-Debug|Any CPU = SL50-Debug|Any CPU
 		SL50-Release|Any CPU = SL50-Release|Any CPU
+		Mono43-Release|Any CPU = Mono43-Release|Any CPU
+		Mono43-Debug|Any CPU = Mono43-Debug|Any CPU
 	EndGlobalSection
 	GlobalSection(ProjectConfigurationPlatforms) = postSolution
-		{E4FA5B53-7D36-429E-8E5C-53D5479242BA}.NET35-Debug|Any CPU.ActiveCfg = NET35-Debug|Any CPU
-		{E4FA5B53-7D36-429E-8E5C-53D5479242BA}.NET35-Debug|Any CPU.Build.0 = NET35-Debug|Any CPU
-		{E4FA5B53-7D36-429E-8E5C-53D5479242BA}.NET35-Release|Any CPU.ActiveCfg = NET35-Release|Any CPU
-		{E4FA5B53-7D36-429E-8E5C-53D5479242BA}.NET35-Release|Any CPU.Build.0 = NET35-Release|Any CPU
-		{E4FA5B53-7D36-429E-8E5C-53D5479242BA}.NET40-Debug|Any CPU.ActiveCfg = NET40-Debug|Any CPU
-		{E4FA5B53-7D36-429E-8E5C-53D5479242BA}.NET40-Debug|Any CPU.Build.0 = NET40-Debug|Any CPU
-		{E4FA5B53-7D36-429E-8E5C-53D5479242BA}.NET40-Release|Any CPU.ActiveCfg = NET40-Release|Any CPU
-		{E4FA5B53-7D36-429E-8E5C-53D5479242BA}.NET40-Release|Any CPU.Build.0 = NET40-Release|Any CPU
-		{E4FA5B53-7D36-429E-8E5C-53D5479242BA}.NET45-Debug|Any CPU.ActiveCfg = NET45-Debug|Any CPU
-		{E4FA5B53-7D36-429E-8E5C-53D5479242BA}.NET45-Debug|Any CPU.Build.0 = NET45-Debug|Any CPU
-		{E4FA5B53-7D36-429E-8E5C-53D5479242BA}.NET45-Release|Any CPU.ActiveCfg = NET45-Release|Any CPU
-		{E4FA5B53-7D36-429E-8E5C-53D5479242BA}.NET45-Release|Any CPU.Build.0 = NET45-Release|Any CPU
-		{E4FA5B53-7D36-429E-8E5C-53D5479242BA}.SL40-Debug|Any CPU.ActiveCfg = SL40-Debug|Any CPU
-		{E4FA5B53-7D36-429E-8E5C-53D5479242BA}.SL40-Debug|Any CPU.Build.0 = SL40-Debug|Any CPU
-		{E4FA5B53-7D36-429E-8E5C-53D5479242BA}.SL40-Release|Any CPU.ActiveCfg = SL40-Release|Any CPU
-		{E4FA5B53-7D36-429E-8E5C-53D5479242BA}.SL40-Release|Any CPU.Build.0 = SL40-Release|Any CPU
-		{E4FA5B53-7D36-429E-8E5C-53D5479242BA}.SL50-Debug|Any CPU.ActiveCfg = SL50-Debug|Any CPU
-		{E4FA5B53-7D36-429E-8E5C-53D5479242BA}.SL50-Debug|Any CPU.Build.0 = SL50-Debug|Any CPU
-		{E4FA5B53-7D36-429E-8E5C-53D5479242BA}.SL50-Release|Any CPU.ActiveCfg = SL50-Release|Any CPU
-		{E4FA5B53-7D36-429E-8E5C-53D5479242BA}.SL50-Release|Any CPU.Build.0 = SL50-Release|Any CPU
+		{087AD3BF-5E40-450D-8138-FBB5F57AC474}.Mono43-Debug|Any CPU.ActiveCfg = Mono43-Debug|Any CPU
+		{087AD3BF-5E40-450D-8138-FBB5F57AC474}.Mono43-Debug|Any CPU.Build.0 = Mono43-Debug|Any CPU
+		{087AD3BF-5E40-450D-8138-FBB5F57AC474}.Mono43-Release|Any CPU.ActiveCfg = Mono43-Release|Any CPU
+		{087AD3BF-5E40-450D-8138-FBB5F57AC474}.Mono43-Release|Any CPU.Build.0 = Mono43-Release|Any CPU
 		{087AD3BF-5E40-450D-8138-FBB5F57AC474}.NET35-Debug|Any CPU.ActiveCfg = NET35-Debug|Any CPU
 		{087AD3BF-5E40-450D-8138-FBB5F57AC474}.NET35-Debug|Any CPU.Build.0 = NET35-Debug|Any CPU
 		{087AD3BF-5E40-450D-8138-FBB5F57AC474}.NET35-Release|Any CPU.ActiveCfg = NET35-Release|Any CPU
@@ -73,8 +58,6 @@ Global
 		{087AD3BF-5E40-450D-8138-FBB5F57AC474}.NET40-Release|Any CPU.Build.0 = NET40-Release|Any CPU
 		{087AD3BF-5E40-450D-8138-FBB5F57AC474}.NET45-Debug|Any CPU.ActiveCfg = NET45-Debug|Any CPU
 		{087AD3BF-5E40-450D-8138-FBB5F57AC474}.NET45-Debug|Any CPU.Build.0 = NET45-Debug|Any CPU
-		{087AD3BF-5E40-450D-8138-FBB5F57AC474}.NET45-Release|Any CPU.ActiveCfg = NET45-Release|Any CPU
-		{087AD3BF-5E40-450D-8138-FBB5F57AC474}.NET45-Release|Any CPU.Build.0 = NET45-Release|Any CPU
 		{087AD3BF-5E40-450D-8138-FBB5F57AC474}.SL40-Debug|Any CPU.ActiveCfg = SL40-Debug|Any CPU
 		{087AD3BF-5E40-450D-8138-FBB5F57AC474}.SL40-Debug|Any CPU.Build.0 = SL40-Debug|Any CPU
 		{087AD3BF-5E40-450D-8138-FBB5F57AC474}.SL40-Release|Any CPU.ActiveCfg = SL40-Release|Any CPU
@@ -83,22 +66,41 @@ Global
 		{087AD3BF-5E40-450D-8138-FBB5F57AC474}.SL50-Debug|Any CPU.Build.0 = SL50-Debug|Any CPU
 		{087AD3BF-5E40-450D-8138-FBB5F57AC474}.SL50-Release|Any CPU.ActiveCfg = SL50-Release|Any CPU
 		{087AD3BF-5E40-450D-8138-FBB5F57AC474}.SL50-Release|Any CPU.Build.0 = SL50-Release|Any CPU
-		{FA79D6B4-30B1-444A-A627-ED283BF6406B}.NET35-Debug|Any CPU.ActiveCfg = NET35-Debug|Any CPU
-		{FA79D6B4-30B1-444A-A627-ED283BF6406B}.NET35-Debug|Any CPU.Build.0 = NET35-Debug|Any CPU
-		{FA79D6B4-30B1-444A-A627-ED283BF6406B}.NET35-Release|Any CPU.ActiveCfg = NET35-Release|Any CPU
-		{FA79D6B4-30B1-444A-A627-ED283BF6406B}.NET35-Release|Any CPU.Build.0 = NET35-Release|Any CPU
-		{FA79D6B4-30B1-444A-A627-ED283BF6406B}.NET40-Debug|Any CPU.ActiveCfg = NET40-Debug|Any CPU
-		{FA79D6B4-30B1-444A-A627-ED283BF6406B}.NET40-Debug|Any CPU.Build.0 = NET40-Debug|Any CPU
-		{FA79D6B4-30B1-444A-A627-ED283BF6406B}.NET40-Release|Any CPU.ActiveCfg = NET40-Release|Any CPU
-		{FA79D6B4-30B1-444A-A627-ED283BF6406B}.NET40-Release|Any CPU.Build.0 = NET40-Release|Any CPU
-		{FA79D6B4-30B1-444A-A627-ED283BF6406B}.NET45-Debug|Any CPU.ActiveCfg = NET45-Debug|Any CPU
-		{FA79D6B4-30B1-444A-A627-ED283BF6406B}.NET45-Debug|Any CPU.Build.0 = NET45-Debug|Any CPU
-		{FA79D6B4-30B1-444A-A627-ED283BF6406B}.NET45-Release|Any CPU.ActiveCfg = NET45-Release|Any CPU
-		{FA79D6B4-30B1-444A-A627-ED283BF6406B}.NET45-Release|Any CPU.Build.0 = NET45-Release|Any CPU
-		{FA79D6B4-30B1-444A-A627-ED283BF6406B}.SL40-Debug|Any CPU.ActiveCfg = SL40-Debug|Any CPU
-		{FA79D6B4-30B1-444A-A627-ED283BF6406B}.SL40-Release|Any CPU.ActiveCfg = SL40-Release|Any CPU
-		{FA79D6B4-30B1-444A-A627-ED283BF6406B}.SL50-Debug|Any CPU.ActiveCfg = SL50-Debug|Any CPU
-		{FA79D6B4-30B1-444A-A627-ED283BF6406B}.SL50-Release|Any CPU.ActiveCfg = SL50-Release|Any CPU
+		{15410E1F-E79F-43B6-B403-228768DF793D}.Mono43-Debug|Any CPU.ActiveCfg = Mono43-Debug|Any CPU
+		{15410E1F-E79F-43B6-B403-228768DF793D}.Mono43-Debug|Any CPU.Build.0 = Mono43-Debug|Any CPU
+		{15410E1F-E79F-43B6-B403-228768DF793D}.Mono43-Release|Any CPU.ActiveCfg = Mono43-Release|Any CPU
+		{15410E1F-E79F-43B6-B403-228768DF793D}.Mono43-Release|Any CPU.Build.0 = Mono43-Release|Any CPU
+		{15410E1F-E79F-43B6-B403-228768DF793D}.NET35-Debug|Any CPU.ActiveCfg = NET35-Debug|Any CPU
+		{15410E1F-E79F-43B6-B403-228768DF793D}.NET35-Release|Any CPU.ActiveCfg = NET35-Release|Any CPU
+		{15410E1F-E79F-43B6-B403-228768DF793D}.NET40-Debug|Any CPU.ActiveCfg = NET40-Debug|Any CPU
+		{15410E1F-E79F-43B6-B403-228768DF793D}.NET40-Debug|Any CPU.Build.0 = NET40-Debug|Any CPU
+		{15410E1F-E79F-43B6-B403-228768DF793D}.NET40-Release|Any CPU.ActiveCfg = NET40-Release|Any CPU
+		{15410E1F-E79F-43B6-B403-228768DF793D}.NET40-Release|Any CPU.Build.0 = NET40-Release|Any CPU
+		{15410E1F-E79F-43B6-B403-228768DF793D}.NET45-Debug|Any CPU.ActiveCfg = NET45-Debug|Any CPU
+		{15410E1F-E79F-43B6-B403-228768DF793D}.NET45-Debug|Any CPU.Build.0 = NET45-Debug|Any CPU
+		{15410E1F-E79F-43B6-B403-228768DF793D}.SL40-Debug|Any CPU.ActiveCfg = SL40-Debug|Any CPU
+		{15410E1F-E79F-43B6-B403-228768DF793D}.SL40-Release|Any CPU.ActiveCfg = SL40-Release|Any CPU
+		{15410E1F-E79F-43B6-B403-228768DF793D}.SL50-Debug|Any CPU.ActiveCfg = SL50-Debug|Any CPU
+		{15410E1F-E79F-43B6-B403-228768DF793D}.SL50-Release|Any CPU.ActiveCfg = SL50-Release|Any CPU
+		{6EEEC4D0-17B6-474C-AF22-6B8BA2E9DD94}.Mono43-Debug|Any CPU.ActiveCfg = Mono43-Debug|Any CPU
+		{6EEEC4D0-17B6-474C-AF22-6B8BA2E9DD94}.Mono43-Release|Any CPU.ActiveCfg = Mono43-Release|Any CPU
+		{6EEEC4D0-17B6-474C-AF22-6B8BA2E9DD94}.NET35-Debug|Any CPU.ActiveCfg = SL40-Release|Any CPU
+		{6EEEC4D0-17B6-474C-AF22-6B8BA2E9DD94}.NET35-Release|Any CPU.ActiveCfg = SL40-Release|Any CPU
+		{6EEEC4D0-17B6-474C-AF22-6B8BA2E9DD94}.NET40-Debug|Any CPU.ActiveCfg = SL40-Release|Any CPU
+		{6EEEC4D0-17B6-474C-AF22-6B8BA2E9DD94}.NET40-Release|Any CPU.ActiveCfg = SL40-Release|Any CPU
+		{6EEEC4D0-17B6-474C-AF22-6B8BA2E9DD94}.NET45-Debug|Any CPU.ActiveCfg = NET45-Debug|Any CPU
+		{6EEEC4D0-17B6-474C-AF22-6B8BA2E9DD94}.SL40-Debug|Any CPU.ActiveCfg = SL40-Debug|Any CPU
+		{6EEEC4D0-17B6-474C-AF22-6B8BA2E9DD94}.SL40-Debug|Any CPU.Build.0 = SL40-Debug|Any CPU
+		{6EEEC4D0-17B6-474C-AF22-6B8BA2E9DD94}.SL40-Release|Any CPU.ActiveCfg = SL40-Release|Any CPU
+		{6EEEC4D0-17B6-474C-AF22-6B8BA2E9DD94}.SL40-Release|Any CPU.Build.0 = SL40-Release|Any CPU
+		{6EEEC4D0-17B6-474C-AF22-6B8BA2E9DD94}.SL50-Debug|Any CPU.ActiveCfg = SL50-Debug|Any CPU
+		{6EEEC4D0-17B6-474C-AF22-6B8BA2E9DD94}.SL50-Debug|Any CPU.Build.0 = SL50-Debug|Any CPU
+		{6EEEC4D0-17B6-474C-AF22-6B8BA2E9DD94}.SL50-Release|Any CPU.ActiveCfg = SL50-Release|Any CPU
+		{6EEEC4D0-17B6-474C-AF22-6B8BA2E9DD94}.SL50-Release|Any CPU.Build.0 = SL50-Release|Any CPU
+		{D680B5DB-B943-4BB5-891A-1695DEF86A3A}.Mono43-Debug|Any CPU.ActiveCfg = Mono43-Debug|Any CPU
+		{D680B5DB-B943-4BB5-891A-1695DEF86A3A}.Mono43-Debug|Any CPU.Build.0 = Mono43-Debug|Any CPU
+		{D680B5DB-B943-4BB5-891A-1695DEF86A3A}.Mono43-Release|Any CPU.ActiveCfg = Mono43-Release|Any CPU
+		{D680B5DB-B943-4BB5-891A-1695DEF86A3A}.Mono43-Release|Any CPU.Build.0 = Mono43-Release|Any CPU
 		{D680B5DB-B943-4BB5-891A-1695DEF86A3A}.NET35-Debug|Any CPU.ActiveCfg = NET35-Debug|Any CPU
 		{D680B5DB-B943-4BB5-891A-1695DEF86A3A}.NET35-Debug|Any CPU.Build.0 = NET35-Debug|Any CPU
 		{D680B5DB-B943-4BB5-891A-1695DEF86A3A}.NET35-Release|Any CPU.ActiveCfg = NET35-Release|Any CPU
@@ -109,8 +111,6 @@ Global
 		{D680B5DB-B943-4BB5-891A-1695DEF86A3A}.NET40-Release|Any CPU.Build.0 = NET40-Release|Any CPU
 		{D680B5DB-B943-4BB5-891A-1695DEF86A3A}.NET45-Debug|Any CPU.ActiveCfg = NET45-Debug|Any CPU
 		{D680B5DB-B943-4BB5-891A-1695DEF86A3A}.NET45-Debug|Any CPU.Build.0 = NET45-Debug|Any CPU
-		{D680B5DB-B943-4BB5-891A-1695DEF86A3A}.NET45-Release|Any CPU.ActiveCfg = NET45-Release|Any CPU
-		{D680B5DB-B943-4BB5-891A-1695DEF86A3A}.NET45-Release|Any CPU.Build.0 = NET45-Release|Any CPU
 		{D680B5DB-B943-4BB5-891A-1695DEF86A3A}.SL40-Debug|Any CPU.ActiveCfg = SL40-Debug|Any CPU
 		{D680B5DB-B943-4BB5-891A-1695DEF86A3A}.SL40-Debug|Any CPU.Build.0 = SL40-Debug|Any CPU
 		{D680B5DB-B943-4BB5-891A-1695DEF86A3A}.SL40-Release|Any CPU.ActiveCfg = SL40-Release|Any CPU
@@ -119,34 +119,48 @@ Global
 		{D680B5DB-B943-4BB5-891A-1695DEF86A3A}.SL50-Debug|Any CPU.Build.0 = SL50-Debug|Any CPU
 		{D680B5DB-B943-4BB5-891A-1695DEF86A3A}.SL50-Release|Any CPU.ActiveCfg = SL50-Release|Any CPU
 		{D680B5DB-B943-4BB5-891A-1695DEF86A3A}.SL50-Release|Any CPU.Build.0 = SL50-Release|Any CPU
-		{6EEEC4D0-17B6-474C-AF22-6B8BA2E9DD94}.NET35-Debug|Any CPU.ActiveCfg = SL40-Release|Any CPU
-		{6EEEC4D0-17B6-474C-AF22-6B8BA2E9DD94}.NET35-Release|Any CPU.ActiveCfg = SL40-Release|Any CPU
-		{6EEEC4D0-17B6-474C-AF22-6B8BA2E9DD94}.NET40-Debug|Any CPU.ActiveCfg = SL40-Release|Any CPU
-		{6EEEC4D0-17B6-474C-AF22-6B8BA2E9DD94}.NET40-Release|Any CPU.ActiveCfg = SL40-Release|Any CPU
-		{6EEEC4D0-17B6-474C-AF22-6B8BA2E9DD94}.NET45-Debug|Any CPU.ActiveCfg = NET45-Debug|Any CPU
-		{6EEEC4D0-17B6-474C-AF22-6B8BA2E9DD94}.NET45-Release|Any CPU.ActiveCfg = NET45-Release|Any CPU
-		{6EEEC4D0-17B6-474C-AF22-6B8BA2E9DD94}.SL40-Debug|Any CPU.ActiveCfg = SL40-Debug|Any CPU
-		{6EEEC4D0-17B6-474C-AF22-6B8BA2E9DD94}.SL40-Debug|Any CPU.Build.0 = SL40-Debug|Any CPU
-		{6EEEC4D0-17B6-474C-AF22-6B8BA2E9DD94}.SL40-Release|Any CPU.ActiveCfg = SL40-Release|Any CPU
-		{6EEEC4D0-17B6-474C-AF22-6B8BA2E9DD94}.SL40-Release|Any CPU.Build.0 = SL40-Release|Any CPU
-		{6EEEC4D0-17B6-474C-AF22-6B8BA2E9DD94}.SL50-Debug|Any CPU.ActiveCfg = SL50-Debug|Any CPU
-		{6EEEC4D0-17B6-474C-AF22-6B8BA2E9DD94}.SL50-Debug|Any CPU.Build.0 = SL50-Debug|Any CPU
-		{6EEEC4D0-17B6-474C-AF22-6B8BA2E9DD94}.SL50-Release|Any CPU.ActiveCfg = SL50-Release|Any CPU
-		{6EEEC4D0-17B6-474C-AF22-6B8BA2E9DD94}.SL50-Release|Any CPU.Build.0 = SL50-Release|Any CPU
-		{15410E1F-E79F-43B6-B403-228768DF793D}.NET35-Debug|Any CPU.ActiveCfg = NET35-Debug|Any CPU
-		{15410E1F-E79F-43B6-B403-228768DF793D}.NET35-Release|Any CPU.ActiveCfg = NET35-Release|Any CPU
-		{15410E1F-E79F-43B6-B403-228768DF793D}.NET40-Debug|Any CPU.ActiveCfg = NET40-Debug|Any CPU
-		{15410E1F-E79F-43B6-B403-228768DF793D}.NET40-Debug|Any CPU.Build.0 = NET40-Debug|Any CPU
-		{15410E1F-E79F-43B6-B403-228768DF793D}.NET40-Release|Any CPU.ActiveCfg = NET40-Release|Any CPU
-		{15410E1F-E79F-43B6-B403-228768DF793D}.NET40-Release|Any CPU.Build.0 = NET40-Release|Any CPU
-		{15410E1F-E79F-43B6-B403-228768DF793D}.NET45-Debug|Any CPU.ActiveCfg = NET45-Debug|Any CPU
-		{15410E1F-E79F-43B6-B403-228768DF793D}.NET45-Debug|Any CPU.Build.0 = NET45-Debug|Any CPU
-		{15410E1F-E79F-43B6-B403-228768DF793D}.NET45-Release|Any CPU.ActiveCfg = NET45-Release|Any CPU
-		{15410E1F-E79F-43B6-B403-228768DF793D}.NET45-Release|Any CPU.Build.0 = NET45-Release|Any CPU
-		{15410E1F-E79F-43B6-B403-228768DF793D}.SL40-Debug|Any CPU.ActiveCfg = SL40-Debug|Any CPU
-		{15410E1F-E79F-43B6-B403-228768DF793D}.SL40-Release|Any CPU.ActiveCfg = SL40-Release|Any CPU
-		{15410E1F-E79F-43B6-B403-228768DF793D}.SL50-Debug|Any CPU.ActiveCfg = SL50-Debug|Any CPU
-		{15410E1F-E79F-43B6-B403-228768DF793D}.SL50-Release|Any CPU.ActiveCfg = SL50-Release|Any CPU
+		{E4FA5B53-7D36-429E-8E5C-53D5479242BA}.Mono43-Debug|Any CPU.ActiveCfg = Mono43-Debug|Any CPU
+		{E4FA5B53-7D36-429E-8E5C-53D5479242BA}.Mono43-Debug|Any CPU.Build.0 = Mono43-Debug|Any CPU
+		{E4FA5B53-7D36-429E-8E5C-53D5479242BA}.Mono43-Release|Any CPU.ActiveCfg = Mono43-Release|Any CPU
+		{E4FA5B53-7D36-429E-8E5C-53D5479242BA}.Mono43-Release|Any CPU.Build.0 = Mono43-Release|Any CPU
+		{E4FA5B53-7D36-429E-8E5C-53D5479242BA}.NET35-Debug|Any CPU.ActiveCfg = NET35-Debug|Any CPU
+		{E4FA5B53-7D36-429E-8E5C-53D5479242BA}.NET35-Debug|Any CPU.Build.0 = NET35-Debug|Any CPU
+		{E4FA5B53-7D36-429E-8E5C-53D5479242BA}.NET35-Release|Any CPU.ActiveCfg = NET35-Release|Any CPU
+		{E4FA5B53-7D36-429E-8E5C-53D5479242BA}.NET35-Release|Any CPU.Build.0 = NET35-Release|Any CPU
+		{E4FA5B53-7D36-429E-8E5C-53D5479242BA}.NET40-Debug|Any CPU.ActiveCfg = NET40-Debug|Any CPU
+		{E4FA5B53-7D36-429E-8E5C-53D5479242BA}.NET40-Debug|Any CPU.Build.0 = NET40-Debug|Any CPU
+		{E4FA5B53-7D36-429E-8E5C-53D5479242BA}.NET40-Release|Any CPU.ActiveCfg = NET40-Release|Any CPU
+		{E4FA5B53-7D36-429E-8E5C-53D5479242BA}.NET40-Release|Any CPU.Build.0 = NET40-Release|Any CPU
+		{E4FA5B53-7D36-429E-8E5C-53D5479242BA}.NET45-Debug|Any CPU.ActiveCfg = NET45-Debug|Any CPU
+		{E4FA5B53-7D36-429E-8E5C-53D5479242BA}.NET45-Debug|Any CPU.Build.0 = NET45-Debug|Any CPU
+		{E4FA5B53-7D36-429E-8E5C-53D5479242BA}.SL40-Debug|Any CPU.ActiveCfg = SL40-Debug|Any CPU
+		{E4FA5B53-7D36-429E-8E5C-53D5479242BA}.SL40-Debug|Any CPU.Build.0 = SL40-Debug|Any CPU
+		{E4FA5B53-7D36-429E-8E5C-53D5479242BA}.SL40-Release|Any CPU.ActiveCfg = SL40-Release|Any CPU
+		{E4FA5B53-7D36-429E-8E5C-53D5479242BA}.SL40-Release|Any CPU.Build.0 = SL40-Release|Any CPU
+		{E4FA5B53-7D36-429E-8E5C-53D5479242BA}.SL50-Debug|Any CPU.ActiveCfg = SL50-Debug|Any CPU
+		{E4FA5B53-7D36-429E-8E5C-53D5479242BA}.SL50-Debug|Any CPU.Build.0 = SL50-Debug|Any CPU
+		{E4FA5B53-7D36-429E-8E5C-53D5479242BA}.SL50-Release|Any CPU.ActiveCfg = SL50-Release|Any CPU
+		{E4FA5B53-7D36-429E-8E5C-53D5479242BA}.SL50-Release|Any CPU.Build.0 = SL50-Release|Any CPU
+		{FA79D6B4-30B1-444A-A627-ED283BF6406B}.Mono43-Debug|Any CPU.ActiveCfg = Mono43-Debug|Any CPU
+		{FA79D6B4-30B1-444A-A627-ED283BF6406B}.Mono43-Debug|Any CPU.Build.0 = Mono43-Debug|Any CPU
+		{FA79D6B4-30B1-444A-A627-ED283BF6406B}.Mono43-Release|Any CPU.ActiveCfg = Mono43-Release|Any CPU
+		{FA79D6B4-30B1-444A-A627-ED283BF6406B}.Mono43-Release|Any CPU.Build.0 = Mono43-Release|Any CPU
+		{FA79D6B4-30B1-444A-A627-ED283BF6406B}.NET35-Debug|Any CPU.ActiveCfg = NET35-Debug|Any CPU
+		{FA79D6B4-30B1-444A-A627-ED283BF6406B}.NET35-Debug|Any CPU.Build.0 = NET35-Debug|Any CPU
+		{FA79D6B4-30B1-444A-A627-ED283BF6406B}.NET35-Release|Any CPU.ActiveCfg = NET35-Release|Any CPU
+		{FA79D6B4-30B1-444A-A627-ED283BF6406B}.NET35-Release|Any CPU.Build.0 = NET35-Release|Any CPU
+		{FA79D6B4-30B1-444A-A627-ED283BF6406B}.NET40-Debug|Any CPU.ActiveCfg = NET40-Debug|Any CPU
+		{FA79D6B4-30B1-444A-A627-ED283BF6406B}.NET40-Debug|Any CPU.Build.0 = NET40-Debug|Any CPU
+		{FA79D6B4-30B1-444A-A627-ED283BF6406B}.NET40-Release|Any CPU.ActiveCfg = NET40-Release|Any CPU
+		{FA79D6B4-30B1-444A-A627-ED283BF6406B}.NET40-Release|Any CPU.Build.0 = NET40-Release|Any CPU
+		{FA79D6B4-30B1-444A-A627-ED283BF6406B}.NET45-Debug|Any CPU.ActiveCfg = NET45-Debug|Any CPU
+		{FA79D6B4-30B1-444A-A627-ED283BF6406B}.NET45-Debug|Any CPU.Build.0 = NET45-Debug|Any CPU
+		{FA79D6B4-30B1-444A-A627-ED283BF6406B}.SL40-Debug|Any CPU.ActiveCfg = SL40-Debug|Any CPU
+		{FA79D6B4-30B1-444A-A627-ED283BF6406B}.SL40-Release|Any CPU.ActiveCfg = SL40-Release|Any CPU
+		{FA79D6B4-30B1-444A-A627-ED283BF6406B}.SL50-Debug|Any CPU.ActiveCfg = SL50-Debug|Any CPU
+		{FA79D6B4-30B1-444A-A627-ED283BF6406B}.SL50-Release|Any CPU.ActiveCfg = SL50-Release|Any CPU
+	EndGlobalSection
+	GlobalSection(NestedProjects) = preSolution
 	EndGlobalSection
 	GlobalSection(SolutionProperties) = preSolution
 		HideSolutionNode = FALSE
diff --git a/src/Castle.Core.Tests-SL/Castle.Core.Tests-SL.csproj b/src/Castle.Core.Tests-SL/Castle.Core.Tests-SL.csproj
index 7c84647..e57d7e0 100644
--- a/src/Castle.Core.Tests-SL/Castle.Core.Tests-SL.csproj
+++ b/src/Castle.Core.Tests-SL/Castle.Core.Tests-SL.csproj
@@ -10,10 +10,8 @@
     <UpgradeBackupLocation />
   </PropertyGroup>
   <PropertyGroup>
-    <Configuration Condition=" '$(Configuration)' == '' ">SL50-Debug</Configuration>
+    <Configuration Condition=" '$(Configuration)' == '' ">SL40-Debug</Configuration>
     <Platform Condition=" '$(Platform)' == '' ">AnyCPU</Platform>
-    <ProductVersion>8.0.50727</ProductVersion>
-    <SchemaVersion>2.0</SchemaVersion>
     <ProjectGuid>{6EEEC4D0-17B6-474C-AF22-6B8BA2E9DD94}</ProjectGuid>
     <ProjectTypeGuids>{A1591282-1198-4647-A2B1-27E5FF5F6F3B};{fae04ec0-301f-11d3-bf4b-00c04f79efbc}</ProjectTypeGuids>
     <OutputType>Library</OutputType>
@@ -100,7 +98,7 @@
     <ErrorReport>prompt</ErrorReport>
     <WarningLevel>4</WarningLevel>
     <CodeAnalysisRuleSet>AllRules.ruleset</CodeAnalysisRuleSet>
-  </PropertyGroup>  
+  </PropertyGroup>
   <PropertyGroup Condition="'$(Configuration)|$(Platform)' == 'NET45-Debug|AnyCPU'">
     <OutputPath>bin\NET45-Debug\</OutputPath>
     <DefineConstants>TRACE;SILVERLIGHT</DefineConstants>
@@ -113,15 +111,27 @@
     <Prefer32Bit>false</Prefer32Bit>
     <NoConfig>true</NoConfig>
   </PropertyGroup>
-  <PropertyGroup Condition="'$(Configuration)|$(Platform)' == 'NET45-Release|AnyCPU'">
+  <PropertyGroup Condition=" '$(Configuration)|$(Platform)' == 'Mono43-Release|AnyCPU' ">
+    <DebugType>pdbonly</DebugType>
+    <Optimize>true</Optimize>
     <OutputPath>bin\NET45-Release\</OutputPath>
     <DefineConstants>TRACE;SILVERLIGHT</DefineConstants>
-    <Optimize>true</Optimize>
+    <ErrorReport>prompt</ErrorReport>
     <NoStdLib>true</NoStdLib>
-    <DebugType>pdbonly</DebugType>
     <PlatformTarget>AnyCPU</PlatformTarget>
+    <CodeAnalysisRuleSet>AllRules.ruleset</CodeAnalysisRuleSet>
+    <NoConfig>true</NoConfig>
+  </PropertyGroup>
+  <PropertyGroup Condition=" '$(Configuration)|$(Platform)' == 'Mono43-Debug|AnyCPU' ">
+    <DebugType>pdbonly</DebugType>
+    <Optimize>true</Optimize>
+    <OutputPath>bin\NET45-Debug\</OutputPath>
+    <DefineConstants>TRACE;SILVERLIGHT</DefineConstants>
     <ErrorReport>prompt</ErrorReport>
+    <NoStdLib>true</NoStdLib>
+    <PlatformTarget>AnyCPU</PlatformTarget>
     <CodeAnalysisRuleSet>AllRules.ruleset</CodeAnalysisRuleSet>
+    <Prefer32Bit>false</Prefer32Bit>
     <NoConfig>true</NoConfig>
   </PropertyGroup>
   <ItemGroup>
@@ -158,7 +168,7 @@
     <None Include="Properties\AppManifest.xml" />
   </ItemGroup>
   <Import Project="$(MSBuildExtensionsPath)\Microsoft\Silverlight\v4.0\Microsoft.Silverlight.CSharp.targets" Condition="$(MSBuildTargets) == 'Silverlight 4.0'" />
-  <Import Project="$(MSBuildExtensionsPath)\Microsoft\Silverlight\v5.0\Microsoft.Silverlight.CSharp.targets" Condition="$(MSBuildTargets) == 'Silverlight 5.0'" />  
+  <Import Project="$(MSBuildExtensionsPath)\Microsoft\Silverlight\v5.0\Microsoft.Silverlight.CSharp.targets" Condition="$(MSBuildTargets) == 'Silverlight 5.0'" />
   <Import Project="$(RootPath)\Settings.proj" />
   <Import Project="$(BuildScriptsPath)\Castle.Common.targets" />
   <!-- To modify your build process, add your task inside one of the targets below and uncomment it. 
